#include "obj_dir/Vga.h"
#include "tb.h"

void App::init() {

    memory = (uint8_t*) malloc(65536);

    for (int i = 0; i < 2048; i++) {

        memory[0xF000 + i] = (i < 1024 ? i & 255 : 0x01);
        memory[0xF800 + i] = font8x8[i];
    }
}

// Код фрейма
void App::frame() {

    // 100k x 50 = 5.0 Mhz (в 5 раз медленнее)
    for (int i = 0; i < 100000; i++) {

        vga->data = memory[0xF000 + vga->address];

        vga->clock = 0; vga->eval();
        vga->clock = 1; vga->eval();

        dsub(vga->hs, vga->vs, 65536*(vga->r*16) + 256*(vga->g*16) + vga->b*16);
    }
}

int main(int argc, char* argv[]) {

    App* app = new App();   // Создать окно приложения
    while (app->main());    // Выполнение цикла каждые 1/50 сек
    return app->destroy();  // Закрыть окно
}
